#include<bits/stdc++.h>

typedef long long ll;
const int MAXN = 310;
const ll INF = 1e18;

int n, m;
ll k, dp[MAXN][MAXN];
void solve()
{
    std::cin >> n >> m >> k;
    for (int i = 0; i <= n; i ++)
        for (int j = 0; j <= m; j ++)
            dp[i][j] = INF;
    
    dp[0][0] = 0;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {
            ll val = (i * j - k);
            dp[i][j] = val * val;

            for (int d = 1; d < i; d ++)
            {
                dp[i][j] = std::min(dp[i][j], dp[d][j] + dp[i - d][j]);
            }

            for (int d = 1; d < j; d ++)
            {
                dp[i][j] = std::min(dp[i][j], dp[i][d] + dp[i][j - d]);
            }
        
        }

    std::cout << dp[n][m] << std::endl;

}
int main()
{
    solve();
    return 0;
}