#include<bits/stdc++.h>

using namespace std;

const int maxn = 35;

int n, par[maxn];
vector < pair < int, int > > adj[maxn];
void build_graph()
{
    ///cout << "char " << (char)('-') << endl;
    string s;
    cin >> s;
    //cout << s << endl;
    int num = 0, node = -1;
    int sign = 1, df = 0;
    for (int i = 0; i < s.size(); i ++)
    {
        ///cout << "HERE " << s[i] << endl;
        char c = s[i];
        ///cout << c << endl;
        if (c == '(')
        {
            ++ n;
            par[n] = node;
            ///cout << "add to " << par[n] << " " << node
            if (par[n] != -1)
                adj[par[n]].push_back({num * sign, n});
            sign = 1;
            num = 0;
            df = 0;
            node = n;
        }
        else
        if (c == ')')
        {
            if (df != 0)   
            {
                adj[node].push_back({num * sign, ++ n});
                par[n] = node;
                sign = 1;
                num = 0;
                df = 0;
            }
            node = par[node];
        }
        else
        if (c == '-')
        {
            df = 1;
            sign = -1;
        }
        else
        if (c >= '0' && c <= '9')
        {
            df = 1;
            num = num * 10 + c - '0';
        }
        else
        if (c == ',')
        {
            ///cout << "add to " << node << " " << n + 1 << endl;
            if (df != 0)
            {
                adj[node].push_back({num * sign, ++ n});
                par[n] = node;
                sign = 1;
                num = 0;
                df = 0;
            }
        }
        else
        {
            //cout << i << endl;
            //cout << c << endl;
            assert(false);
        
        
        }

        ///cout << "state " << s[i] << " " << node << " n: " << n << endl;
    }
}

void print_graph()
{
    cout << "Number of vertices: " << n << endl;
    for (int i = 1; i <= n; i ++)
    {
        cout << "Vertex: " << i << endl;
        for (pair < int, int > cur : adj[i])
        {
            cout << "Child: " << cur.second << " Arm: " << cur.first << endl;
        } 
    }
}

int cnt_leaves = 0;

int weight[maxn], rid[maxn];


/**bool dfs(int v)
{
    weight[v] = 0;
    if (adj[v].size() == 0)
    {
        weight[v] = p[rid[v]];
    }
    bool fine = true;
    int arm = 0;
    for (pair < int, int > nb : adj[v])
    {
        int u = nb.second;
        if (dfs(u) == false)
            fine = false;
        weight[v] += weight[u];
        arm = arm + nb.first * weight[u];
    }

    if (arm != 0)
        fine = false;
    return fine;


}*/

int sub[maxn];
void calc(int v)
{
    if (adj[v].empty())
    {
        sub[v] = 1;
        return;
    }

    for (pair < int, int >  nb : adj[v])
    {
        calc(nb.second);
        sub[v] += sub[nb.second];
    }
}

void print(int v)
{
    if (adj[v].size() > 0)
    {
        cout << '(';
        int last = - 1;
        for (pair < int, int > u : adj[v])
        {
            if (last != -1)
                cout << ',';
            print(u.second);
            last = 1;
        }
        cout << ')';
    }
    else
    {
        cout << weight[v];
    }
}

const int maxd = 17;

vector < pair < int, vector < int > > > way[maxn];
vector < int > viable[maxn];
vector < int > path;

int weight_mask[(1 << maxd)];
void brute(int v, int i, int bitmask, int arm)
{

    ///cout << "brute " << v << " " << i << " " << bitmask << " " << arm << endl; 
    if (i == adj[v].size())
    {
        if (arm == 0)
        {
            viable[v].push_back(bitmask);
            way[v].push_back({bitmask, path});
        }
        return;
    }

    for (int cur : viable[adj[v][i].second])
    {
        if ((cur & bitmask) > 0)
            continue;
        ///cout << "trans " << adj[v][i].first << " : " << weight_mask[cur] << " " << cur << endl;
        path.push_back(cur);
        brute(v, i + 1, (bitmask | cur), arm + weight_mask[cur] * adj[v][i].first);
        path.pop_back();
    }
}

void solve_dp(int v)
{
    if (adj[v].empty())
    {
        ///cout << "here " << endl;
        for (int bit = 0; bit < cnt_leaves; bit ++)
        {
            viable[v].push_back((1 << bit));
            way[v].push_back({(1 << bit), {(1 << bit)}});
        }

        ///cout << "leaf " << v << " " << viable[v].size() << endl;
        return;
    }

    for (pair < int, int > nb : adj[v])
        solve_dp(nb.second);
    brute(v, 0, 0, 0); 
    ///cout << "vertex " << v << " " << viable[v].size() << endl;
}

void assign_values(int v, int bitmask)
{
    if (adj[v].size() == 0)
    {
        int bit = 0;
        while((1 << bit) != bitmask)
            bit ++;
        weight[v] = bit + 1;
        return; 
    }

    vector < int > path;
    for (pair < int, vector < int > > cur : way[v])
    {
        if (cur.first == bitmask)
            path = cur.second;
    }
    
    for (int i = 0; i < adj[v].size(); i ++)
    {
        assign_values(adj[v][i].second, path[i]);
    }
}
void simulate()
{
   
    for (int i = 1; i <= n; i ++)
        if (adj[i].size() == 0)
        {
            cnt_leaves ++;
            rid[i] = cnt_leaves;
        }


    for (int i = 0; i < (1 << cnt_leaves); i ++)
    {
        for (int bit = 0; bit < cnt_leaves; bit ++)
        {
            if ((i & (1 << bit)) > 0)
                weight_mask[i] += (bit + 1);
        }
    }
    calc(1);
   
    solve_dp(1);

    assign_values(1, (1 << cnt_leaves) - 1);
    print(1);
    ///cout << viable[1].size() << endl;
}
void solve()
{
    build_graph();
    //print_graph();
    ///assert(false);
    simulate();
    ///assert(false);
}
int main()
{
    //freopen("test2.txt", "r", stdin);
    solve();
    return 0;
}
/**
(-3(-1(-1(-1,1,2),3),2),3(-2,1,2),6(-2,3))
(-3,-1,2(-2,-1,1))
*/