#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 22e6;

int n;

int main()
{
    std::cin >> n;
    int lg = 0;

    while ((1 << lg) <= n)
    {
        lg++;
    }

    std::cout << 2 * lg + 1 << '\n';
    for (int bit = -1 ; bit < 2 ; ++bit)
    {
        for (int i = 0 ; i <= 2 * lg ; ++i)
        {
            if (i == lg)
            {
                if (bit == -1)
                {
                    std::cout << "R S " << 0 << '\n'; 
                } else
                {
                    std::cout << "L " << (bit == -1 ? 'S' : bit == 0 ? '0' : '1') << ' ' << i << '\n'; 
                }
            } else if (i < lg)
            {
                if (bit == -1)
                {
                    std::cout << "R S " << lg + 1 << '\n';
                } else if (bit == 0)
                {
                    if (i == lg - 1)
                    {
                        std::cout << "H\n";
                    } else
                    {
                        std::cout << "R 1 " << i + 1 << '\n';
                    }
                } else
                {
                    std::cout << "L(C) 0 " << lg << '\n';
                }
            } else if (i > lg)
            {
                if (i < 2 * lg)
                {
                    std::cout << "R " << ((n & (1 << i - lg - 1)) > 0) << ' ' << i + 1 << '\n';
                } else
                {
                    std::cout << "L " << ((n & (1 << i - lg - 1)) > 0) << ' ' << lg << '\n';
                }
            }
        }
    }

    return 0;
}