#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 22e6;

int n;

void solve500()
{
    if (n == 0)
    {
        std::cout << 1 << '\n';
        std::cout << "H\n";
        std::cout << "H\n";
        std::cout << "H\n";
        return;
    }

    int lg = 0;

    while ((1 << lg) <= n)
    {
        lg++;
    }

    std::cout << 2 * lg + 1 << '\n';
    for (int bit = -1 ; bit < 2 ; ++bit)
    {
        for (int i = 0 ; i <= 2 * lg ; ++i)
        {
            if (i == lg)
            {
                if (bit == -1)
                {
                    std::cout << "R S " << 0 << '\n'; 
                } else
                {
                    std::cout << "L " << (bit == -1 ? 'S' : bit == 0 ? '0' : '1') << ' ' << i << '\n'; 
                }
            } else if (i < lg)
            {
                if (bit == -1)
                {
                    std::cout << "R S " << lg + 1 << '\n';
                } else if (bit == 0)
                {
                    if (i == lg - 1)
                    {
                        std::cout << "H\n";
                    } else
                    {
                        std::cout << "R 1 " << i + 1 << '\n';
                    }
                } else
                {
                    std::cout << "LC 0 " << lg << '\n';
                }
            } else if (i > lg)
            {
                if (i < 2 * lg)
                {
                    std::cout << "R " << ((n & (1 << i - lg - 1)) > 0) << ' ' << i + 1 << '\n';
                } else
                {
                    std::cout << "L " << ((n & (1 << i - lg - 1)) > 0) << ' ' << lg << '\n';
                }
            }
        }
    }
}

int main()
{
    std::cin >> n;
    if (n <= 5)
    {
        solve500();
        return 0;
    }

    int lg = 0;
    while ((1 << lg) <= n)
    {
        lg++;
    }

    lg--;
    std::cout << lg + 3 << '\n';
    for (int bit = -1 ; bit < 2 ; ++bit)
    {
        for (int i = 0 ; i < lg + 3 ; ++i)
        {
            if (i == lg + 2)
            {
                if (bit == -1)
                {
                    std::cout << "H\n"; // not happening
                } else if (bit == 0)
                {
                    std::cout << "L 1 " << lg << '\n';
                } else
                {
                    std::cout << "H\n";
                }
            
                continue;
            }

            if (i == lg + 1)
            {
                if (bit == -1)
                {
                    std::cout << "RC S " << 0 << '\n'; 
                } else
                {
                    std::cout << "L 1 " << lg + 1 << '\n'; 
                }

                continue;
            }

            if (i == lg)
            {
                if (bit == -1)
                {
                    if (n & 1) std::cout << "RC S " << 0 << '\n';
                    else std::cout << "R S " << 0 << '\n';
                } else
                {
                    std::cout << "L " << (bit == -1 ? 'S' : bit == 0 ? '0' : '1') << ' ' << lg << '\n';
                }

                continue;
            }

            if (bit == -1)
            {
                std::cout << "R S " << 0 << '\n';
                continue;
            }

            if (bit == 1)
            {
                std::cout << "LC 0 " << lg + 1 << '\n';
                continue;
            }

            if (i == lg - 1)
            {
                std::cout << "R " << ((n & (1 << i + 1)) > 0) << ' ' << lg + 2 << '\n';
                continue;
            }

            std::cout << "R " << ((n & (1 << i + 1)) > 0) << ' ' << i + 1 << '\n';
        }
    }

    return 0;
}