#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct seg
{
    int a,b,num;
    seg(){}
    seg(int a, int b) : a(a), b(b) {}
};

const int maxn = 1e5+5;
int n,m;
seg sp[maxn];
int lead[maxn];
bool par[maxn];
int ans[maxn];

bool daddy(seg p1, seg p2)
{
    bool f1,f2;
    f1 = f2 = false;
    if(p1.a > p1.b) f1 = true;
    if(p2.a > p2.b) f2 = true;

    if(!f1&&f2) return p1.b <= p2.b || p1.a >= p2.a;
    if(f1&&!f2) return false;
    return p2.a <= p1.a && p1.b <= p2.b;///kogato f1==f2
}

bool cmp(seg p1, seg p2)
{
    if(p1.a == p2.a) return true;///edno i sushto
    return p1.a < p2.a;
}

int used[maxn];

void check_impossible()
{
    memset(used,0,sizeof(used));
    int chis;
    for(int i = 1; i <= m; i++)
    {
        if(ans[i]==0) chis = 1;
        else chis = 2;

        int z = sp[i].a;
        used[z] |= chis;
        while(z != sp[i].b)
        {
            z++;
            if(z>n) z = 1;
            used[z] |= chis;
        }
    }
    for(int i = 1; i <= n; i++)
    {
        if(used[i]!=3)
        {
            cout << "impossible" << endl;
            exit(0);
        }
    }
}

int find_lead(int x)
{
    if(lead[x]==x) return x;
    return lead[x] = find_lead(lead[x]);
}

void ocveti(seg beg, int chis)
{
    int z = beg.a;
    used[z] |= chis;
    while(z != beg.b)
    {
        z++;
        if(z>n) z = 1;
        used[z] |= chis;
    }
}

bool proveri(seg beg, int chis)
{
    int z = beg.a;
    if(used[z]==chis) return true;
    while(z != beg.b)
    {
        z++;
        if(z>n) z = 1;
        if(used[z]==chis) return true;
    }
    return false;
}

void read()
{
    cin >> n >> m;
    for(int i = 1; i <= n; i++) lead[i] = i;
    for(int i = 1; i <= m; i++)
    {
        cin >> sp[i].a >> sp[i].b;
        sp[i].num = i;
    }
    for(int i = 1; i <= m; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            if(i==j) continue;
            if(par[i]) break;
            if(daddy(sp[i],sp[j]))
            {
                int x = find_lead(i);
                int y = find_lead(j);
                if(x!=y) lead[x] = y;
                par[i] = true;
            }
        }
    }
    vector<seg>v;
    for(int i = 1; i <= m; i++)
    {
        if(find_lead(i)==i) v.push_back(sp[i]);
        else ocveti(sp[i],3);
    }

    sort(v.begin(),v.end(),cmp);
    int chis = 0;
    int old = 1;///old = 1;
    for(seg nb : v)
    {
        ans[nb.num] = 0;
        bool p[4] = {0,0,0,0};
        for(int j = 0; j < 4; j++) p[j] = proveri(nb,j);

        if(!p[0])
        {
            if(!p[1]) chis = 1;
            else if(!p[2]) chis = 2;
            chis = old;///chis = old;
        }
        else
        {
            if(!p[1]&&p[2]) chis = 1;
            else if(p[1]&&!p[2]) chis = 2;

            chis = 3-old;///chis = old;
        }

        ans[nb.num] = chis-1;
        ocveti(nb,chis);
        old = chis;
    }
    for(int i = 1; i <= m; i++) if(find_lead(i)!=i) ans[i] = 1-ans[find_lead(i)];
    check_impossible();
    for(int i = 1; i <= m; i++) cout << ans[i];
    cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	read();
return 0;
}
