#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
int n;
vector<int> leaves;
int leafValues[100];
vector<pair<int,int> > g[1000];
int currNode=1;
void build(int u,string s){
    if(s.size()==0){
        leaves.push_back(u);
        n++;
        return;
    }
    int len=s.size();
    int openBrackets=0;
    int coef=0;
    bool neg=false;
    string currChild;
    for(int i=1;i<len-1;i++){
        if(s[i]=='('){
            openBrackets++;
            currChild.push_back(s[i]);
            continue;
        }
        if(s[i]==')'){
            openBrackets--;
            currChild.push_back(s[i]);
            continue;
        }
        if(openBrackets>0){
            currChild.push_back(s[i]);
            continue;
        }
        if(s[i]=='-'){
            neg=true;
            continue;
        }
        if(isdigit(s[i])){
            coef*=10;
            coef+=s[i]-'0';
            continue;
        }
        if(s[i]==','){
            if(neg) coef=-coef;
            g[u].push_back({currNode++,coef});
            build(currNode-1,currChild);
            currChild.clear();
            coef=0;
            neg=false;
        }
    }
    if(neg) coef=-coef;
    g[u].push_back({currNode++,coef});
    build(currNode-1,currChild);
}
int val[1000];
bool used[100];
void dfs(int u){
    if(g[u].size()==0) return;
    val[u]=0;
    for(auto p: g[u]){
        int v=p.first;
        dfs(v);
        val[u]+=val[v];
    }
}
void dfsPrint(int u){
    if(g[u].size()==0){
        cout<<val[u];
        return;
    }
    cout<<"(";
    for(int i=0;i<g[u].size();i++){
        dfsPrint(g[u][i].first);
        if(i<g[u].size()-1) cout<<",";
    }
    cout<<")";
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin>>s;
    build(0,s);
    int perms=1;
    for(int i=0;i<n;i++){
        leafValues[i]=n-i;
        perms*=i+1;
    }
    srand(time(0));
    for(int i=0;i<n;i++){
        swap(leafValues[i],leafValues[rand()%n]);
    }
    for(int i=0;i<perms;i++){
        for(int i=0;i<n;i++){
            val[leaves[i]]=leafValues[i];
        }
        dfs(0);
        bool flag=true;
        for(int i=0;i<n;i++){
            int sum=0;
            for(auto p: g[i]){
                sum+=val[p.first]*p.second;
            }
            if(sum!=0){
                flag=false;
                break;
            }
        }
        if(flag) break;
        prev_permutation(leafValues,leafValues+n);
    }
    dfsPrint(0);
    return 0;
}
