#include<bits/stdc++.h>

struct Segment
{
    int a, b;

    Segment(int _a = 0, int _b = 0)
    {
        a = _a;
        b = _b;
    }

    void input()
    {
        std::cin >> a >> b;
    }
};

const int MAXN = 1e3 + 10;

int n, m;
Segment s[MAXN];
void input()
{
    std::cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    s[i].input();
}

void impossible()
{
    std::cout << "impossible" << std::endl;
    exit(0);
}
int marked[2][MAXN];

void solve()
{
    input();
    for (int mask = 0; mask < (1 << m); mask ++)
    {
        for (int i = 1; i <= n; i ++)
            marked[0][i] = marked[1][i] = 0;

        for (int i = 1; i <= m; i ++)
        {
            int mark = ((mask & (1 << (i - 1))) > 0);
            if (s[i].a <= s[i].b)
                for (int j = s[i].a; j <= s[i].b; j ++)
                    marked[mark][j] = 1;
            else
            {
                for (int j = s[i].a; j <= n; j ++)
                    marked[mark][j] = 1;
                for (int j = 1; j <= s[i].b; j ++)
                    marked[mark][j] = 1;
            }
        }

        bool done = true;
        for (int i = 1; i <= n; i ++)
        {
            if (!marked[0][i] || !marked[1][i])
            {
                done = false;
                break;
            }
        }

        if (!done)
            continue;

        for (int i = 1; i <= m; i ++)
        {
            int mark = ((mask & (1 << (i - 1))) > 0);
            std::cout << mark;
        }
        std::cout << std::endl;
        return;
    }

    impossible();
}
int main()
{
    solve();
    return 0;
}