#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

const int maxn = 1e6 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, x, a[maxn], leap[maxn];

void input()
{
    cin >> n >> x;
    for (int i = 1; i <= n; i ++)
        cin >> a[i];
}

void find_coverage()
{
    for (int i = 1; i <= n; i ++)
        leap[i] = min(n + 1, i + a[i] + 1);

    for (int i = 1; i <= n; i ++)
    {
        int r = i + a[i];
        if (r > n)
            r = n;

        for (int j = max(1, i - a[i]); j <= r; j ++)
            leap[j] = max(leap[j], r + 1);
    }
}

ll dp[maxn];
const ll inf = 1e18;

ll solve_states()
{
    ll res = 0;
    for (int i = n; i > 0; i --)
    {
        dp[i] = n - leap[i] + 1 + dp[leap[i]];
        res += dp[i];

        ///cout << "state " << i << " leap " << leap[i] << " dp " << dp[i] << endl;
    }
    return res;
}

void check_antennas()
{
    ll ans = inf;
    for (int i = 0; i <= n; i ++)
    {
        int sv = a[i];
        a[i] = x;
        find_coverage();
        ll cur = solve_states();
        //cout << "here " << i << " " << cur << endl;
        //exit(0);
        a[i] = sv;
        ans = min(ans, cur);
    }
    
    
    cout << ans << endl;
}
void solve()
{
    input();
    ///find_coverage();
    check_antennas();
}
int main()
{
    speed();
    solve();
    return 0;
}
/*
3 1
1 0 0

5 0 
2 1 0 0 1

*/