#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

int n,a,b,c[MAXN];
vector<int> primes,v[MAXN];
unordered_map< int , vector<int> > del;

int divv[MAXN],num[MAXN],to[MAXN],tt,dist[MAXN],ret[MAXN],fr[MAXN];
vector<int> euler;
int li[MAXN],tim;

vector< pair<int,int> > tree[MAXN];
stack<int> st;

void eratosthen(){
    for(int i=2;i<=100000;i++){
        if(divv[i]==0){
            divv[i]=i;
            primes.push_back(i);
        }

        for(int f=0;f<primes.size() and primes[f]*i<=100000;f++){
            divv[primes[f]*i]=primes[f];
        }
    }
}

void dfs(int x,int p,int dep){

    dist[x]=dep; tt++; num[x]=tt; ret[tt]=x;
    fr[x]=euler.size();

    euler.push_back(num[x]);

    for(int i=0;i<v[x].size();i++){
        if(v[x][i]==p)continue;
        dfs(v[x][i],x,dep+1);

        euler.push_back(num[x]);
    }

    to[x]=tt;
}

int power[20],lg[2*MAXN];
int dp[2*MAXN][20];

void calc(){
    power[0]=1;
    for(int i=1;i<20;i++)power[i]=power[i-1]*2;
    for(int i=2;i<=2*n;i++)lg[i]=lg[i/2]+1;

    for(int i=0;i<euler.size();i++){
        dp[i][0]=euler[i];
    }
    
    for(int len=1;len<20;len++){
        for(int i=0;i+power[len]-1<euler.size();i++){
            dp[i][len] = min( dp[i][len-1] , dp[i+power[len-1]][len-1] );
        }
    }
}

int lca(int x,int y){
    if(fr[x]>fr[y])swap(x,y);
    x=fr[x]; y=fr[y];

    return ret[ min( dp[x][lg[y-x+1]] , dp[y-power[lg[y-x+1]]+1][lg[y-x+1]] ) ];
}

int distance(int x,int y){
    return dist[x] + dist[y] - 2*dist[lca(x,y)];
}

bool cmp(int x,int y){
    return num[x]<num[y];
}

int maxdist,root,ans;

void dfs2(int x,int p,int dep){
    if(dep>maxdist){
        root=x;
        maxdist=dep;
    }

    for(int i=0;i<tree[x].size();i++){
        if(tree[x][i].first==p)continue;
        dfs2(tree[x][i].first,x,dep+tree[x][i].second);
    }
}

void diameter(int x){
    maxdist=0;
    dfs2(x,0,0);

    maxdist=0;
    dfs2(root,0,0);

    ans=max(ans,maxdist);
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    eratosthen();

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>c[i];
        int ss=c[i];

        for(int f=0;f<primes.size() and primes[f]*primes[f]<=c[i];f++){
            if(c[i]%primes[f]==0){
                del[primes[f]].push_back(i);

                while(c[i]%primes[f]==0)c[i]/=primes[f];
            }
        }

        if(c[i]>1){
            del[c[i]].push_back(i);
        }

        c[i]=ss;
    }

    for(int i=1;i<=n-1;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    dfs(1,0,0);
    calc();

    for(pair< int , vector<int> > curr:del){
        
        sort(curr.second.begin(),curr.second.end(),cmp);

        int sz=curr.second.size(); tim++;

        for(int i:curr.second)li[i]=tim;

        for(int i=0;i<sz-1;i++){
            if(li[lca(curr.second[i],curr.second[i+1])]==tim)continue;
            li[lca(curr.second[i],curr.second[i+1])]=tim;

            curr.second.push_back(lca(curr.second[i],curr.second[i+1]));
        }

        sort(curr.second.begin(),curr.second.end(),cmp);

        for(int i:curr.second){
            while(!st.empty() and num[i]>to[st.top()]){
                st.pop();
            }

            if(!st.empty()){
                tree[st.top()].push_back({i,distance(i,st.top())});
                tree[i].push_back({st.top(),distance(i,st.top())});
            }

            st.push(i);
        }
        
        diameter(curr.second[0]);

        for(int i:curr.second)tree[i].clear();
        while(!st.empty())st.pop();
    }

    cout<<ans<<"\n";
    

    return 0;
}
