#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct Node
{
    int num,koef;
    Node(){};
    Node(int ni, int ki)
    {
        num = ni;
        koef = ki;
    }
};

const int maxn = 512;

string s = "";
vector<Node>g[maxn];
int idx = 1;

int get_koef(int i)
{
    int res = 0;
    int des = 1;
    for(int j = i-1; j >= 0; j--)
    {
        if('0'<=s[j]&&s[j]<='9') res += des*(s[j]-'0');
        else
        {
            if(s[j]=='-') res = -res;
            return res;
        }
        des *= 10;
    }
    return res;
}

void read(int l, int r, int par)
{
    stack<int>bal;
    int last = 0;
    for(int i = l; i <= r; i++)
    {
        if(s[i]=='(') bal.push(i);
        if(s[i]==')')
        {
            last = bal.top();
            bal.pop();
        }
        if(s[i]==','&&bal.empty())
        {
            idx++;
            if(s[i-1]==')')
            {
                g[par].push_back({idx,get_koef(last)});
                read(last+1,i-2,idx);
            }
            else
            {
                g[par].push_back({idx,get_koef(i)});
            }
        }
    }
    idx++;
    if(s[r]==')')
    {
        g[par].push_back({idx,get_koef(last)});
        read(last+1,r-1,idx);
    }
    else
    {
        g[par].push_back({idx,get_koef(r+1)});
    }
}

void dfs_g(int beg)
{
    cout << beg << "->";
    for(Node nb : g[beg]) cout << nb.num << "+" << nb.koef << " ";
    cout << endl;
    for(Node nb : g[beg]) dfs_g(nb.num);
}



int n,sub[maxn],p[maxn];
vector<int>v;

int used[maxn];
int need,emanuela[maxn];

void dfs_need(int beg)
{
    int don_t = 0;
    for(Node nb : g[beg])
    {
        if(g[nb.num].size()) dfs_need(nb.num);
        else if(!don_t) don_t = nb.num;
    }
    if(don_t)
    {
        emanuela[don_t] = 1;
        need--;
    }
}

bool dfs_check(int beg)
{
    sub[beg] = 0;

    int bal = 0;
    Node don_t = {0,0};
    for(Node nb : g[beg])
    {
        if(g[nb.num].size()==0)
        {
            sub[nb.num] = 0;
            if(!emanuela[nb.num]) sub[nb.num] = p[nb.num];
            else don_t = nb;
        }
        else if(!dfs_check(nb.num)) return false;
        sub[beg] += sub[nb.num];
        bal += (nb.koef*sub[nb.num]);///v prazniq sluchaj 0
    }

    if(don_t.num)
    {
        int ch = 0 - bal;
        sub[don_t.num] = ch/don_t.koef;
        used[sub[don_t.num]]++;
        if(ch%don_t.koef||used[sub[don_t.num]]>1||sub[don_t.num]<need) return false;
    }
    return bal == 0;
}

/*void dfs_prov(int beg)
{
    cout << beg << " " << sub[beg] << endl;
    if(g[beg].size()==0) return;

    cout << beg << "->";
    int bal = 0;
    for(Node nb : g[beg])
    {
        cout << "    " << nb.koef << " " << sub[nb.num];
    }

    cout << endl;
    for(Node nb : g[beg]) dfs_prov(nb.num);
}*/

void dfs_print(int beg)
{
    cout << '(';
    for(int i = 0; i < g[beg].size(); i++)
    {
        Node nb = g[beg][i];
        if(g[nb.num].size()) dfs_print(nb.num);
        else cout << p[nb.num];
        if(i<g[beg].size()-1) cout << ",";
    }
    cout << ')';
}

void solve()
{
    while(true)
    {
        random_shuffle(v.begin(),v.end());
        for(int i = 0; i < need; i++) p[v[i]] = i+1; ///ot 1 do N;
        for(int i = 0; i < n; i++) used[i] = 0;
        if(dfs_check(1))
        {
            dfs_print(1);
            cout << endl;
            return;
        }
    }
}

int main()
{
	///ios_base::sync_with_stdio(false);
	///cin.tie(nullptr);
	string t;
	getline(cin,t);
	for(int i = 0; i < t.size(); i++) if(t[i]!=' ') s += t[i];
	for(int i = 0; i < s.size(); i++) if(s[i]=='?') s[i] = '-';
	read(1,s.size()-2,1);

	for(int i = 1; i <= idx; i++) if(g[i].size()==0) n++;
	need = n;
	dfs_need(1);

	for(int i = 1; i <= idx; i++)
    {
        if(g[i].size()==0&&!emanuela[i]) v.push_back(i);
    }

	solve();
return 0;
}
