#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
int n;
int a[400010];
vector<int> g[400010];
int er[400010];
struct path{
    int u,v,len;
};
path longest[400010];
int T,intime[400010],outtime[400010];
int maxD,logD,depth[400010];
int p[400010][18];
void sieve(){
    for(int i=0;i<=400010;i++){
        er[i]=i;
        longest[i]={-1,-1,-1};
    }
    for(int i=2;i*i<=400010;i++){
        if(er[i]!=i) continue;
        for(int j=i*i;j<=400010;j+=i){
            er[j]=i;
        }
    }
}
unordered_set<int> factor(int N){
    unordered_set<int> ans;
    ans.insert(er[N]);
    N/=er[N];
    while(N>1){
        if(ans.find(er[N])==ans.end()) ans.insert(er[N]);
        N/=er[N];
    }
    return ans;
}
void dfs(int u,int par){
    intime[u]=T++;
    for(auto v: g[u]){
        if(v==par) continue;
        depth[v]=depth[u]+1;
        maxD=max(maxD,depth[v]);
        p[v][0]=u;
        dfs(v,u);
    }
    outtime[u]=T++;
}
void binLift(){
    for(int i=1;(1<<(i-1))<maxD;i++){
        for(int j=0;j<n;j++){
            p[j][i]=p[p[j][i-1]][i-1];
        }
        logD=i;
    }
}
bool isParent(int u,int v){
    return (intime[u]<=intime[v] && outtime[v]<=outtime[u]);
}
int LCA(int u,int v){
    if(u==v) return u;
    if(intime[u]>intime[v]) swap(u,v);
    if(isParent(u,v)) return u;
    for(int i=logD;i>=0;i--){
        if(!isParent(p[u][i],v)) u=p[u][i];
    }
    return p[u][0];
}
int dist(int u,int v){
    return depth[u]+depth[v]-2*depth[LCA(u,v)];
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    sieve();
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    for(int i=0;i<n-1;i++){
        int u,v;
        cin>>u>>v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0,-1);
    binLift();
    for(int i=0;i<n;i++){
        unordered_set<int> f=factor(a[i]);
        for(auto divisor: f){
            if(longest[divisor].u==-1){
                longest[divisor].u=i;
                continue;
            }
            if(longest[divisor].v==-1){
                longest[divisor].v=i;
                longest[divisor].len=dist(longest[divisor].u,longest[divisor].v);
                continue;
            }
            int d1=dist(longest[divisor].u,i);
            int d2=dist(longest[divisor].v,i);
            if(d1>=d2 && d1>longest[divisor].len){
                longest[divisor].v=i;
                longest[divisor].len=d1;
                continue;
            }
            if(d2>d1 && d2>longest[divisor].len){
                longest[divisor].u=i;
                longest[divisor].len=d2;
                continue;
            }
        }
    }
    int ans=0;
    for(int i=0;i<=400000;i++){
        ans=max(ans,longest[i].len);
    }
    cout<<ans;
    return 0;
}
